# Copyright (c) 2000-2012, JPackage Projectc
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/picketlink/%{name}/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define reltag .Final
%define namedversion %{version}%{reltag}

%define groupId org.picketlink.quickstarts

Name:           picketlink-quickstarts
Epoch:          0
Version:        2.1.5
Release:        1%{?dist}
Summary:        PicketLink Federation: Quickstarts Project
Group:          Development/Tools
License:        LGPL
URL:            http://www.jboss.org/picketlink/docs.html
# git clone git://git.app.eng.bos.redhat.com/picketlink/picketlink-quickstarts.git
# cd picketlink-quickstarts && git checkout v2.1.5.Final && cd ..
# HEAD is now at f55381b... Release version change: 2.1.5.Final
# tar czf picketlink-quickstarts-2.1.5.Final-src.tar.gz picketlink-quickstarts
Source0:        %{name}-%{namedversion}-src.tar.gz
Source1:        %{name}-jpp-depmap.xml
Patch0:          %{name}-pom.patch

BuildArch:      noarch

BuildRequires:  jpackage-utils
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2
BuildRequires:  maven2-plugin-war
BuildRequires:  mojo-maven2-plugin-jaxb2
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  ant-contrib
BuildRequires:  picketlink-federation
BuildRequires:  log4j

Requires:       jpackage-utils
Requires:       log4j
Requires:       java

Requires(post):       jpackage-utils
Requires(postun):     jpackage-utils

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
This project provides some examples about using PicketLink Federation.

%package zip
Summary:        zip for %{name}
Group:          Development/Documentation

%description zip
This package contains the zip for %{name}.

%package idp
Summary:        Idp web application for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description idp
This package contains the identity provider web application for %{name}.

%package pdp
Summary:        Pdp web application for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description pdp
This package contains the policy decision point web application for %{name}.

%package sts
Summary:        Sts web application for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description sts
This package contains the security token service of WS-Trust web application for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{name}

%patch0 -p1

%build
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL

%{_bindir}/mvn-jpp -e \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    -Dmaven2.jpp.depmap.file=%{SOURCE1} \
    -Dbinding=jboss -Dbinding-version=as5 \
    -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
    install deploy:deploy

%install
rm -rf $RPM_BUILD_ROOT
echo $(pwd)

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
for artifactId in \
    idp \
    pdp \
    picketlink-sts \
    ; do
install -pm 644 \
  maven2-brew/org/picketlink/quickstarts/${artifactId}/%{namedversion}/${artifactId}-%{namedversion}.pom \
  $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{groupId}-${artifactId}.pom

%add_to_maven_depmap %{groupId} ${artifactId} %{namedversion} JPP/%{groupId} ${artifactId}
done

#webapps
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}

mkdir -p tmp/%{name}-webapps
pushd tmp/%{name}-webapps
unzip ../../target/picketlink-webapps-jboss-as5.zip -d ../
cp ../picketlink/*beans.xml .
mkdir idp.war ; cd idp.war
jar xf ../../picketlink/idp.war
cd .. ; mkdir pdp.war ; cd pdp.war
jar xf ../../picketlink/pdp.war
cd .. ; mkdir picketlink-sts.war ; cd picketlink-sts.war
jar xf ../../picketlink/picketlink-sts.war
popd
cp -pr tmp/%{name}-webapps/* $RPM_BUILD_ROOT%{_datadir}/%{name}

#for the zip
mkdir -p $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev
cp -p target/picketlink-webapps-jboss-as5.zip $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/
chmod 644 $RPM_BUILD_ROOT/%{_javadir}/jbossas-fordev/picketlink-webapps-jboss-as5.zip

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
# Remove unsupported webapps
rm -Rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/picketlink/quickstarts/employee*
rm -Rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/picketlink/quickstarts/idp-*
rm -Rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/picketlink/quickstarts/picketlink-quickstarts*
rm -Rf %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/picketlink/quickstarts/sales*
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
cp -p target/picketlink-webapps-jboss-as5.zip %{buildroot}%{repodirlib}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%post idp
if [ "$1" = "1" ]; then
#create symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   for profile in default web production standard all; do
      ln -sf %{_datadir}/%{name}/idp.war /var/lib/jbossas/server/$profile/deploy
   done
elif [ -d /var/lib/jbossas-web/server ] ; then
   for profile in default production; do
      ln -sf %{_datadir}/%{name}/idp.war /var/lib/jbossas-web/server/$profile/deploy
   done
fi
fi

%preun idp
if [ "$1" = "0" ]; then
#remove symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   rm -fr /var/lib/jbossas/server/{default,web,production,standard,all}/deploy/idp.war
elif [ -d /var/lib/jbossas-web/server ] ; then
   rm -fr /var/lib/jbossas-web/server/{default,production}/deploy/idp.war
fi
fi

%post pdp
if [ "$1" = "1" ]; then
#create symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   for profile in default web production standard all; do
      ln -sf %{_datadir}/%{name}/pdp.war /var/lib/jbossas/server/$profile/deploy
   done
elif [ -d /var/lib/jbossas-web/server ] ; then
   for profile in default production; do
      ln -sf %{_datadir}/%{name}/pdp.war /var/lib/jbossas-web/server/$profile/deploy
   done
fi
fi

%preun pdp
if [ "$1" = "0" ]; then
#remove symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   rm -fr /var/lib/jbossas/server/{default,web,production,standard,all}/deploy/pdp.war
elif [ -d /var/lib/jbossas-web/server ] ; then
   rm -fr /var/lib/jbossas-web/server/{default,production}/deploy/pdp.war
fi
fi

%post sts
if [ "$1" = "1" ]; then
#create symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   for profile in default web production standard all; do
      ln -sf %{_datadir}/%{name}/picketlink-sts.war /var/lib/jbossas/server/$profile/deploy
   done
elif [ -d /var/lib/jbossas-web/server ] ; then
   for profile in default production; do
      ln -sf %{_datadir}/%{name}/picketlink-sts.war /var/lib/jbossas-web/server/$profile/deploy
   done
fi
fi

%preun sts
if [ "$1" = "0" ]; then
#remove symlinks for EAP and EWP
if [ -d /var/lib/jbossas/server ] ; then
   rm -fr /var/lib/jbossas/server/{default,web,production,standard,all}/deploy/picketlink-sts.war
elif [ -d /var/lib/jbossas-web/server ] ; then
   rm -fr /var/lib/jbossas-web/server/{default,production}/deploy/picketlink-sts.war
fi
fi

%files
%defattr(-,root,root,-)
%{_datadir}/maven2/poms/*
%{_datadir}/%{name}/picketlink-sp-jboss-beans.xml
%{_mavendepmapfragdir}

%files zip
%defattr(-,root,root,-)
%{_javadir}*/jbossas-fordev/picketlink-webapps-jboss-as5.zip

%files idp
%defattr(-,root,root,-)
%{_datadir}/%{name}/idp.war
%{_datadir}/%{name}/picketlink-idp-jboss-beans.xml

%files pdp
%defattr(-,root,root,-)
%{_datadir}/%{name}/pdp.war

%files sts
%defattr(-,root,root,-)
%{_datadir}/%{name}/picketlink-sts.war
%{_datadir}/%{name}/picketlink-sts-jboss-beans.xml

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Oct 15 2012 Hui Wang <huwang@redhat.com> - 0:2.1.5.Final-1
- Upgrade to 2.1.5.Final

* Tue Aug 28 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.1.3-2
- Install jboss-beans.xml

* Thu Aug 09 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.1.3-1
- First release
